<html>
<head>
	<title>Massey Sır Paylaşım Şeması</title>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
	<meta http-equiv="X-UA-Compatible" content="IE=edge" />
	<meta name="viewport" content="width=device-width, initial-scale=1">

	<script type="text/javascript" src="jquery-1.10.2.js"></script>
	<!--<link rel="stylesheet" type="text/css" href="bootstrap-3.3.7-dist/css/bootstrap.css">
	<script type="text/javascript" src="bootstrap-3.3.7-dist/js/bootstrap.js"></script>-->
	<style>
		#divMap table, #divMap  th, #divMap  td {
			border: 1px solid black;
		}
		#divMap td {
		  width: 100px;
		  text-align: center;
		}
		table {
			border-collapse: collapse;
		}
		#divEncode {
		  width: auto;
		  height: auto;
		  display: block;
		  justify-content: center;
		}
		.greenBackground {
		  background-color: green;
		}
		.floatingDiv {
		  float: left;
		  width: 100%;
		  height: auto;
		  display: flex;
		  justify-content: center;
		  align-items: flex-end;
		}
    </style>
  
	<script type="text/javascript" src="calculationlib/matrixlib.js"></script>
	<script type="text/javascript" src="calculationlib/ecclib.js"></script>
	<script type="text/javascript" src="calculationlib/polynomial.js"></script>
	<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.6/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>
	<!--<script type="text/javascript" src="MathJax/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>-->
	<script type="text/x-mathjax-config">
		MathJax.Hub.Config({tex2jax: {inlineMath: [['$','$'], ['\\(','\\)']]}});
		MathJax.Localization.setLocale("tr");
	</script>
	<script>
		var WriteFormula = function(divId, TeX) {
			var selector = "#" + divId;
			var selObj = $(selector)
			if(selObj.length > 0){
				var queue = MathJax.Hub.queue;
				var math = MathJax.Hub.getAllJax(divId)[0];
				queue.Push(
					function () { selObj.css('visibility','hidden') },
					//["resetEquationNumbers",MathJax.InputJax.TeX],
					["Text",math,"\\displaystyle{"+TeX+"}"],
					function () { selObj.css('visibility','visible') }
				);
			}
		}
		var AddFormula = function(container, name, tex) {
			var containerSelector = $('#' + container);
			if ($('#' + name).length == 0)
				containerSelector.append("<div id='" + name + "' style='text-align:center; visibility: visible; padding:10;'>");
			else $('#' + name).html("");

			$('#' + name).append($('<script type="math/tex">').text("\\displaystyle{"+tex+"}"));
			MathJax.Hub.Queue(
				//function () { $('#' + name).css('visibility','hidden')
				["Typeset",MathJax.Hub]
				//,function () { $('#' + name).css('visibility','visible') }
			);
		}
		var ReadMatrix = function(text) {
				
			var data = [];
			text = text.replace( /\s\s+/g, ' ' );
			var lines = text.split(/\r|\n/);
			for (var i = 0; i < lines.length; i++) {
				var lineData = [];
				var cells = lines[i].split(' ');
				for (var j = 0; j < cells.length; j++) {
					if(cells[j] != "") {
						lineData.push(parseInt(cells[j]));
					}
				}
				if (lineData.length > 0)
					data.push(lineData);
			}
			return data;
		}
	</script>
</head>

<body>

	<h2>Massey Sır Paylaşım Şeması </h2>

	<h3>Sırı Oluşturma</h3>
	<table>
		<tr>
			<td> <label class="col-sm-2 control-label"><b>GF</b></label> </td>
			<td> <input type="text" id="txtDegree" value="2"/> </td> 
		</tr>
		<tr>
			<td> <label class="col-sm-2 control-label"><b>Kod</b></label> </td>
			<td> 
			<textarea class="form-control" id="txtGeneratorMatrix" rows="5">
1 0 1 0 0
0 1 0 1 0
1 1 0 0 1</textarea>
			</td>
		</tr>
		<tr>
			<td>  <strong>Sır</strong>  </td>
			<td>  <input type="text" id="txtSecret" value="1 0 1 1 1 0 1 1"/> </td>
		</tr>
		<tr>
			<td> </td>
			<td>  <input type="button" id="btnConstructSecret" value="Sırrı Oluştur" />  </td>
		</tr>
	</table>
	<div id="divConstSecretResult"></div>

	<h3>Sırrı Çözme</h3>
	<div id="divFindSecretParams">
		<!--<b>q:</b> <input type='text' id='txtQ2' value='17'/> <br />
		<div id="divSecretInputs"></div>-->
		<input type='button' id='btnFindSecret' value='Sırrı Bul' />
	</div>
	<div id="divFindSecretResult"></div>


	<script type="text/javascript">
		rowCount = 1;
		var access_structure = [];

		var AddAccessSetInput = function(tableId, count, rowId){
			var text = "<tr>";
			for (var i = 1; i < count+1; i++){
				text += "<td> <input type='checkbox' row='" + rowId + "' col='" + i + "' /> </td>"
			}
			text += "</tr>";
			$('#' + tableId + ' tr:last').after(text);
		}
		var CreateInput = function(inputCount, q) {

			var text = "<table>";

			text += "<tr>";
			for (var i = 1; i < inputCount+1; i++)
				text += "<td align='center'>" + i + "</td>";
			text += "</tr>";

			text += "<tr>";
			for (var i = 1; i < inputCount+1; i++)
				text += "<td><input type='text' style='text-align:center;' maxlength='4' size='4' num=" + i + " id='txtInpt" + i + "' /></td>";
			text += "</tr>";

			text += "</table>";
			return text;
		}
		
		var factorial = function(num) {
			var result  = 1;
			for(var i = 1; i <= num; i++)
				result *= i;
			return result;
		}
		var combination = function(n,k) {
			return factorial(n) / (factorial(k) * factorial(n-k));
		}
		var combinations = function(start, end) {
			var data = [];
			for (var i = start; i <= end; i++)
				data.push(i);
			
			var target = [];
			var result = get_combinations(target, data);
			
			return result;
		}
		var get_combinations = function(target, data) {
			
			var result = [];
			for (var i = 0; i < data.length; i++) {
				
				var new_target = target.slice(0);
				var new_data = data.slice(0);
				new_target.push(data[i]);
				new_data = new_data.slice(i+1);
				result.push(new_target);
				var r = get_combinations(new_target, new_data);
				for (j = 0; j < r.length; j++)
					result.push(r[j]);
			}
			return result;
		}
		var sortbylength = function(array) {
			for (var i = 1; i < array.length; i++) {
				for (var j = 0; j < array.length-i; j++) {
					if (array[j].length > array[j+1].length) {
						var tmp = array[j];
						array[j] = array[j+1];
						array[j+1] = tmp;
					}
				}
			}
			return array;
		}
		

		$(document).ready(function () {
			$("input[type='button']").click(function (e) {
				if (e.target.id == "btnConstructSecret") {
					
					var q = parseInt($("#txtDegree").val());
					var generator = new MatrixGenerator(q);
					var processor = new MatrixCalculator(q);
					
					var secret = ReadMatrix($('#txtSecret').val())[0];
					for (var i = 0; i < secret.length; i++)
						secret[i] = secret[i] % q;
					//$('#txtSecret').val(secret.reduce(function(acc, cur) { return "" + acc + " " + cur; }));
					
					var text = $('#txtGeneratorMatrix').val();
					var arr = ReadMatrix(text);
					var generator = new Matrix(arr);
					var code = new ErrorCorrectingCode(generator, q);
					var dualCode = code.DualCode();
					var multiply = processor.Multiply(code.Generator, dualCode.Generator.Transpose());
					
					
					
					var codeM = code.M;
					var codeWords = {};
					var codeWordsText1 = "\\begin{array}{c|cc} word & codeword \\\\ \\hline";
					for (var i = 0; i < q; i++) {
						codeWords[i] = [];
					}
					for (var i = 0; i < codeM; i++) {
						var word = code.GetWord(i)
						var codeword = code.CalculateCodeword(word);
						var firstval = codeword.Data.Get(0,0);
						codeWords[firstval].push(codeword);
						
						var word_orj = word.Text;
						var word_cod = codeword.Text;
						var word_weight = "w=" + codeword.weight;
						var word_support = codeword.supportText;
						codeWordsText1 += word_orj + "&" + word_cod;
								if(i != codeM-1)
									codeWordsText1 += "\\\\";
					}
					codeWordsText1 += "\\end{array}";
					
					
					
					
					var dualM = dualCode.M;
					var dualCodeWords = {};
					access_structure = [];
					var codeWordsText = "\\begin{array}{c|cc} word & codeword & weight & support & minmal & access \\\\ \\hline";
					for (var i = 0; i < dualM; i++) {
						var word = dualCode.GetWord(i)
						var codeword = dualCode.CalculateCodeword(word);
						dualCodeWords[word.Text] = codeword;
					}
					for (var i = 0; i < dualM; i++) {
						var word1 = dualCode.GetWord(i);
						var cw1 = dualCodeWords[word1.Text];
						if (cw1.isZero) continue;
						cw1.isMinimalCodeword = true;
						for (var j = 0; j < dualM; j++) {
							if (i == j) continue;
							var word2 = dualCode.GetWord(j);
							var cw2 = dualCodeWords[word2.Text];
							if (cw2.isZero) continue;
							var isSubset = cw2.support.every(function(val) { return cw1.support.indexOf(val) >= 0; });
							if (isSubset) {
								cw1.isMinimalCodeword = false;
								continue;
							}
						}
					}
					for (var i = 0; i < dualM; i++) {
						var word = dualCode.GetWord(i);
						var codeword = dualCodeWords[word.Text]; // dualCode.CalculateCodeword(word);
						
						var word_orj = word.Text;
						var word_cod = codeword.Text;
						var word_weight = "w=" + codeword.weight;
						var word_support = codeword.supportText;
						var word_isminimal = codeword.isMinimalCodeword;
						var word_isaccessstructure = codeword.isMinimalCodeword & codeword.Get(0) == 1 ? true : false;
						if (codeword.Get(0) == 1)
							access_structure.push(codeword.support.reduce(function(acc, cur) { return "" + acc + "," + cur; }).replace('0,', ''));
						
						codeWordsText += word_orj + "&" + word_cod + "&" + word_weight + "&" + 
											word_support + "&" + word_isminimal  + "&" + word_isaccessstructure;
						if(i != dualM-1)
							codeWordsText += "\\\\";
					}
					codeWordsText += "\\end{array}";
					
					
					
					$("#divConstSecretResult").html("");
					$("#divFindSecretResult").html("");
					
					
					AddFormula("divConstSecretResult", "MathOutputInfo1", "G=" + code.Generator.ToLatex());
					AddFormula("divConstSecretResult", "MathOutputInfo5", codeWordsText1);
					
					AddFormula("divConstSecretResult", "MathOutputInfo2", "H=" + dualCode.Generator.ToLatex());
					AddFormula("divConstSecretResult", "MathOutputInfo4", codeWordsText);
					
					
					var parts = {};
					for (var i = 1; i < code.n; i++)
						parts[i] = [];
					var max = code.M / q;
					for (var i = 0; i < secret.length; i++) {
						var s = secret[i];
						var choose = parseInt(Math.random() * max);
						var partsCodewords = codeWords[s][choose];
						for (var j = 1; j < code.n; j++)
							parts[j].push(partsCodewords.Get(j));
					}
					
					var text = "<table>"
					for (var i = 1; i < code.n; i++){
						var v = parts[i].reduce(function(acc, cur) { return acc + " " + cur; });
						text += "<tr>";
						text += "<td> Katılımcı " +  i + "</td>";
						text += "<td> <input id='txtSharePart" + i + "' type='text' value='" + v + "' </td>";
						text += "</tr>";
					}
					text += "</table>";
					$("#divConstSecretResult").append(text);
					
					return;
					
					$("#divSecretInputs").html(CreateInput(N, q));
				}
				else if (e.target.id == "btnFindSecret") {
					
					$("#divFindSecretResult").html("");
					var q = parseInt($("#txtDegree").val());
					var generator = new MatrixGenerator(q);
					var processor = new MatrixCalculator(q);
					var original_text = $('#txtSecret').val();
					var original_secret = ReadMatrix(original_text)[0];
					for (var i = 0; i < original_secret.length; i++)
						original_secret[i] = original_secret[i] % q;
					original_text = original_secret.reduce(function(acc, cur) { return "" + acc + " " + cur; });
					
					var generatorText = $('#txtGeneratorMatrix').val();
					var generatorArray = ReadMatrix(generatorText);
					var generatorMatrix = new Matrix(generatorArray);
					var code = new ErrorCorrectingCode(generatorMatrix, q);
					
					
					
					var combs = combinations(1, code.n-1);
					combs = sortbylength(combs);
					var text = "<table>";
					text += "<tr>"
					text += "<th>Katılımcılar</th>";
					text += "<th>Sonuç</th>";
					text += "<th>Doğru Konum Sayısı</th>";
					text += "</tr>";
					
					var all_count = combs.length;
					var true_positive = 0;
					var false_positive = 0;
					var false_negative = 0;
					for (var i = 0; i < combs.length; i++) {
						
						var subset = "";
						var c = combs[i];
						for (var k = 0; k < c.length; k++) {
							subset += c[k];
							if (k < c.length-1)
								subset += ",";
						}
						
						secret = "";
						var shares = [];
						var maxLength = 0;
						for (var j = 0; j < c.length; j++) {
							var shareText = $("#txtSharePart" + c[j]).val();
							var shareArray = ReadMatrix(shareText)[0];
							shares.push([ c[j], shareArray ]);
							maxLength = Math.max(shareArray.length, maxLength);
						}
						var data = Array(maxLength).fill(0);
						for (var j = 0; j < maxLength; j++) {
							for (var k = 0; k < shares.length; k++) {
								data[j] = (data[j] + shares[k][1][j]) % q;
							}
						}
						secret = "" + data.reduce(function(acc, cur) { return "" + acc + " " + cur; });
						var style = ""
						if (original_text == secret) {
							style += "class='greenBackground'";
							
							if (access_structure.indexOf(subset) >= 0)
								true_positive += 1;
							else false_positive += 1;
						}
						else {
							if (access_structure.indexOf(subset) >= 0)
								false_negative += 1;
						}
						
						var truePositions = 0;
						for (var j = 0; j < maxLength; j++) {
							if (data[j] == original_secret[j])
								truePositions += 1;
						}
						
						secret = secret.replace(/\&/g, '&amp;');
						secret = secret.replace(/\</g, '&lt;');
						secret = secret.replace(/\>/g, '&gt;');
						secret = secret.replace(/\"/g, '&quot;');
						
						text += "<tr>";
						text += "<td " + style + ">";
						text += subset;
						text += "</td>";
						text += "<td " + style + ">";
						text += secret;
						text += "</td>";
						text += "<td align='center' " + style + ">";
						text += truePositions;
						text += "</td>";
						text += "</tr>"
					}
					text += "</table>";
					
					$("#divFindSecretResult").append("<br />");
					$("#divFindSecretResult").append("Bütün kombinasyonların sayısı: " + all_count + "<br />");
					$("#divFindSecretResult").append("True Positive: " + true_positive + "<br />");
					$("#divFindSecretResult").append("False Positive: " + false_positive + "<br />");
					$("#divFindSecretResult").append("False Negative: " + false_negative + "<br />");
					$("#divFindSecretResult").append("<br />");
					$("#divFindSecretResult").append(text);
					
				}
				
			});
		});
	</script>
</body>

</html>
